//+------------------------------------------------------------------+
//|                                          Trendline_Alpha_v1.2mq4 |
//|                                                                  |
//| Developers: If you improve this code then please send            |
//|             copies of the improved code to the original          |
//|             developer.                                           |
//|                                                                  |
//| History: 1.0 Wilko   Initail version                             |
//|          1.1 Wilko   Alerts added                                |
//|          1.2 Wilko   Trendlines 3 & 4 added                      |
//|          1.3 Wilko   Style and Width options added to Trendlines |
//|          1.4 Wilko   Added missing style and width on low TL     |
//+------------------------------------------------------------------+
#property copyright "Wilko042@gmail.com"
#property link      ""

#property indicator_chart_window
#include <WinUser32.mqh>
#include <stdlib.mqh>

   //---------------------------------------------------------    
   // External Variables
   //---------------------------------------------------------       
   extern string TL1S="--- Trendline 1 ---";
   extern bool TL1_Show=true;
   extern int TL1_BarsBack=100;
   extern bool TL1_Use_Close=false;
   extern string TL2S="--- Trendline 2 ---";
   extern bool TL2_Show=true;
   extern int TL2_BarsBack=300;
   extern bool TL2_Use_Close=false;
   extern string TL3S="--- Trendline 3 ---";
   extern bool TL3_Show=true;
   extern int TL3_BarsBack=900;
   extern bool TL3_Use_Close=false;
   extern string TL4S="--- Trendline 4 ---";
   extern bool TL4_Show=true;
   extern int TL4_BarsBack=5000;
   extern bool TL4_Use_Close=false;
   extern string Styles1="--- Styles ---";   
   extern string Styles2="--- 0-Solid, 1-Dash, 2-Dot, 3-DashDot, 4-DashDotDot ---";   
   extern color TL1_High_Colour=MediumSeaGreen;
   extern color TL1_Low_Colour=MediumSeaGreen;
   extern int TL1_Style=0;
   extern int TL1_Width=1;
   extern color TL2_High_Colour=Purple;
   extern color TL2_Low_Colour=Purple;
   extern int TL2_Style=0;
   extern int TL2_Width=1;
   extern color TL3_High_Colour=Goldenrod;
   extern color TL3_Low_Colour=Goldenrod;
   extern int TL3_Style=0;
   extern int TL3_Width=1;
   extern color TL4_High_Colour=Gray;
   extern color TL4_Low_Colour=Gray;
   extern int TL4_Style=0;
   extern int TL4_Width=1;
   extern string Alerts="--- Alerts ---";
   extern bool TL1_Alert=true;
   extern bool TL2_Alert=true;
   extern bool TL3_Alert=true;
   extern bool TL4_Alert=true;
   extern string Emails="--- E-Mail ---";
   extern bool TL1_Email=false;
   extern bool TL2_Email=false;
   extern bool TL3_Email=false;
   extern bool TL4_Email=false;
   
   //---------------------------------------------------------    
   // Internal Variables
   //---------------------------------------------------------                   
   double High_Price1=0, High_Price2=0;
   int High_Time1=0, High_Time2=0, High_Shift1=0,High_Shift2=0;

   double Low_Price1=0, Low_Price2=0;
   int Low_Time1=0, Low_Time2=0, Low_Shift1=0,Low_Shift2=0;

   int i, arrow_counter=0;
   
   datetime LastAlertTime=-999999;  
   
   int Timeframes[10] = {1,5,15,30,60,240,1440,10080,43200};
   
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   ObjectDelete("TL1_High" );
   ObjectDelete("TL1_Low" );
   ObjectDelete("TL2_High" );
   ObjectDelete("TL2_Low" );
   ObjectDelete("TL3_High" );
   ObjectDelete("TL3_Low" );
   ObjectDelete("TL4_High" );
   ObjectDelete("TL4_Low" );
   for (i=0;i<500;i++)
   {
      ObjectDelete("TL1_High_Close_Break_" + i);
      ObjectDelete("TL1_Low_Close_Break_" + i);
   }
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//----
   //--------------------------------------------------------- 
   // Initialise variables
   //---------------------------------------------------------
   int counted_bars=IndicatorCounted(), counted_bars_alert;  
   
   if (Bars-counted_bars>2) return(0);
   
   //Print ("Next Higher Timeframe = ", Next_Higher_Timeframe(Period()) );
   
   //--------------------------------------------------------- 
   // Draw Trendlines
   //---------------------------------------------------------
   if (TL1_Show) DrawTL("TL1", TL1_BarsBack, TL1_Use_Close, TL1_High_Colour, TL1_Low_Colour, TL1_Style, TL1_Width);
   if (TL2_Show) DrawTL("TL2", TL2_BarsBack, TL2_Use_Close, TL2_High_Colour, TL2_Low_Colour, TL2_Style, TL2_Width);
   if (TL3_Show) DrawTL("TL3", TL3_BarsBack, TL3_Use_Close, TL3_High_Colour, TL3_Low_Colour, TL3_Style, TL3_Width);
   if (TL4_Show) DrawTL("TL4", TL4_BarsBack, TL4_Use_Close, TL4_High_Colour, TL4_Low_Colour, TL4_Style, TL4_Width);
   
   //--------------------------------------------------------- 
   // Check Alerts
   //--------------------------------------------------------- 
   if (TL1_Show && Time[0] > LastAlertTime) Check_Alert("TL1", TL1_Alert, TL1_Email, TL1_High_Colour, TL1_Low_Colour);
   if (TL2_Show && Time[0] > LastAlertTime) Check_Alert("TL2", TL2_Alert, TL2_Email, TL2_High_Colour, TL2_Low_Colour);
   if (TL3_Show && Time[0] > LastAlertTime) Check_Alert("TL3", TL3_Alert, TL3_Email, TL3_High_Colour, TL3_Low_Colour);
   if (TL4_Show && Time[0] > LastAlertTime) Check_Alert("TL4", TL4_Alert, TL4_Email, TL4_High_Colour, TL4_Low_Colour);         
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//---------------------------------------------------------       
// Functions      
//
// TL_High_Break
// TL_Low_Break
// TL_High_Close_Break
// TL_Low_Close_Break
// Check_Alert
// Next_Higher_Timeframe
// DrawTL
//---------------------------------------------------------  

//---------------------------------------------------------       
// Check for a break of TL High         
//---------------------------------------------------------       
bool TL_High_Break(string TL, color TL_Colour)
{
   if (iHigh(NULL, 0, 0) > ObjectGetValueByShift(TL + "_High" , 1))
   {                
      string Obj = TL + "_High_Break_" + arrow_counter;
      ObjectCreate(Obj , OBJ_ARROW, 0, iTime(NULL, 0,0), iHigh(NULL, 0,1)) ;
      ObjectSet(Obj, OBJPROP_ARROWCODE, SYMBOL_ARROWUP);
      ObjectSet(Obj, OBJPROP_COLOR, TL_Colour);
      arrow_counter++;
      
      return (true);
   } else
   return (false);
}

//---------------------------------------------------------       
// Check for a break of TL Low
//---------------------------------------------------------       
bool TL_Low_Break(string TL, color TL_Colour)
{
   if (iLow(NULL, 0, 0) < ObjectGetValueByShift(TL + "_Low" , 1))
   {                
      string Obj = TL + "_Low_Break_" + arrow_counter;
      ObjectCreate(Obj , OBJ_ARROW, 0, iTime(NULL, 0,0), iHigh(NULL, 0,1)) ;
      ObjectSet(Obj, OBJPROP_ARROWCODE, SYMBOL_ARROWUP);
      ObjectSet(Obj, OBJPROP_COLOR, TL_Colour);
      arrow_counter++;
   
      return (true);
   } else
   return (false);
}

//---------------------------------------------------------       
// Check for a Close above High Trendline
//---------------------------------------------------------       
bool TL_High_Close_Break(string TL, color TL_Colour)
{
   if (iClose(NULL, 0, 1) > ObjectGetValueByShift(TL + "_High" , 1))
   {
      string Obj = TL + "_High_Close_Break_" + arrow_counter;
      ObjectCreate(Obj , OBJ_ARROW, 0, iTime(NULL, 0,1), iLow(NULL, 0,1)) ;
      ObjectSet(Obj, OBJPROP_ARROWCODE, SYMBOL_ARROWUP);
      ObjectSet(Obj, OBJPROP_COLOR, TL_Colour);
      arrow_counter++;
   
      return (true);
   } else
   return (false);
}

//---------------------------------------------------------       
// Check for a Close below Low Trendline
//---------------------------------------------------------       
bool TL_Low_Close_Break(string TL, color TL_Colour)
{
   if (iClose(NULL, 0, 1) < ObjectGetValueByShift(TL + "_Low" , 1))
   {              
      string Obj = TL + "_Low_Close_Break_" + arrow_counter;  
      ObjectCreate(Obj , OBJ_ARROW, 0, iTime(NULL, 0,1), iHigh(NULL, 0,1)) ;
      ObjectSet(Obj, OBJPROP_ARROWCODE, SYMBOL_ARROWDOWN);
      ObjectSet(Obj, OBJPROP_COLOR, TL_Colour);
      arrow_counter++;
      
      return (true);
   } else
   return (false);
}

//--------------------------------------------------------- 
// Check Alert 
//--------------------------------------------------------- 
void Check_Alert(string TL, bool TL_Alert, bool TL_Email, color High_Colour, color Low_Colour)
{
      if (TL_High_Close_Break(TL, High_Colour) )
      {
         if (TL_Alert) {Alert (Symbol() + " : Price has closed above Trendline " + TL);}
         if (TL_Email) SendMail (Symbol() + " : Trendline_Alpha Alert","Price has closed above Trendline " + TL);
         LastAlertTime = Time[0];  
      }

      if (TL_Low_Close_Break(TL, Low_Colour) )
      {
         if (TL_Alert) {Alert (Symbol() + " : Price has closed below Trendline " + TL);}
         if (TL_Email) SendMail (Symbol() + " : Trendline_Alpha Alert","Price has closed below Trendline " + TL);
         LastAlertTime = Time[0]; 
      }
      
} // void Check_Alert
   
//---------------------------------------------------------       
// Next_Higher_Timeframe
//
// Returns the value of the next higher timeframe
//--------------------------------------------------------- 
int Next_Higher_Timeframe(int TF)
{
   int Timeframes[9] = {1,5,15,30,60,240,1440,10080,43200};
   int TF_index = ArrayBsearch(Timeframes, TF);
   if (TF_index == 9) return (Timeframes[TF_index]);
   else return (Timeframes[TF_index+1]);
}

//---------------------------------------------------------       
// Draw Trendline
//--------------------------------------------------------- 
void DrawTL(string TL, int BarsBack, bool Use_Close, color High_Colour, color Low_Colour, int Style, int Width)
{
   //---------------------------------------------------------    
   // Find the high starting point
   //---------------------------------------------------------    
   High_Price1=0;High_Price2=0;High_Time1=0;High_Time2=0;High_Shift1=0;High_Shift2=0;
 
   if (Use_Close) 
   {
      High_Price1 = Close[iHighest(NULL, 0, MODE_CLOSE,BarsBack,1)];
      High_Time1 = Time[iHighest(NULL, 0, MODE_CLOSE,BarsBack,1)];  
      High_Shift1= iBarShift(NULL, 0, High_Time1, false);      
      //---------------------------------------------------------    
      // Set the second point to be the 2nd bar as a starting point 
      // I found poorly drawn trendlines when picking the next bar as a starting point       
      //---------------------------------------------------------    
      High_Price2 = Close[High_Shift1-2];  
      High_Time2 = Time[High_Shift1-2];  
      High_Shift2= High_Shift1-2;
   } else 
   {
      High_Price1 = High[iHighest(NULL, 0, MODE_HIGH,BarsBack,1)];
      High_Time1 = Time[iHighest(NULL, 0, MODE_HIGH,BarsBack,1)];  
      High_Shift1= iBarShift(NULL, 0, High_Time1, false);
      //---------------------------------------------------------    
      // Set the second point to be the 2nd bar as a starting point 
      //---------------------------------------------------------    
      High_Price2 = High[High_Shift1-2];  
      High_Time2 = Time[High_Shift1-2];  
      High_Shift2= High_Shift1-2;
   }
  
   //---------------------------------------------------------   
   // Delete trendline if High_Price1 has changed
   //---------------------------------------------------------            
   if ( ObjectGet(TL + "_High" , OBJPROP_PRICE1) != High_Price1 ) ObjectDelete(TL + "_High" );
   
   //---------------------------------------------------------   
   // Draw High TL
   //---------------------------------------------------------         
   if ( High_Price1>0 && High_Price2>0 
        && ObjectGet(TL + "_High" , OBJPROP_PRICE2) != High_Price2
   )
   {
      if (ObjectFind(TL + "_High") < 0) 
      { 
         ObjectCreate(TL + "_High" , OBJ_TREND, 0, High_Time1, High_Price1, High_Time2, High_Price2);
         ObjectSet(TL + "_High" , OBJPROP_RAY, TRUE);
         ObjectSet(TL + "_High" , OBJPROP_COLOR, High_Colour);
         ObjectSet(TL + "_High" , OBJPROP_STYLE, Style);
         ObjectSet(TL + "_High" , OBJPROP_WIDTH, Width);
      }
   }
   
   //---------------------------------------------------------    
   // Change the value of the second point if price penetrates the line
   //---------------------------------------------------------   
   if (Use_Close) 
   {
      for ( i=High_Shift1-2; i>1; i-- )
      {
        if (  iClose(NULL, 0,i) > ObjectGetValueByShift(TL + "_High" ,i) )
        {         
           ObjectMove(TL + "_High" , 1, iTime(NULL, 0, i), iClose(NULL, 0,i) );     
        }
      }
   } else
   {
      for ( i=High_Shift1-2; i>1; i-- )
      {
        if (  iHigh(NULL, 0,i) > ObjectGetValueByShift(TL + "_High" ,i) )
        {         
           ObjectMove(TL + "_High" , 1, iTime(NULL, 0, i), iHigh(NULL, 0,i) );     
        }
      }
   }
   
   //---------------------------------------------------------    
   // Find the low starting point 
   //---------------------------------------------------------    
   Low_Price1=0;Low_Price2=0;Low_Time1=0;Low_Time2=0;

   if (Use_Close) 
   {
      Low_Price1 = Close[iLowest(NULL, 0, MODE_CLOSE,BarsBack,1)];  
      Low_Time1 = Time[iLowest(NULL, 0, MODE_CLOSE,BarsBack,1)];  
      Low_Shift1= iBarShift(NULL, 0, Low_Time1, false);
      //---------------------------------------------------------    
      // Set the second point to be the 2nd bar as a starting point 
      //---------------------------------------------------------       
      Low_Price2 = Close[Low_Shift1-2];  
      Low_Time2 = Time[Low_Shift1-2];  
      Low_Shift2= Low_Shift1-2;
   } else
   {
      Low_Price1 = Low[iLowest(NULL, 0, MODE_LOW,BarsBack,1)];  
      Low_Time1 = Time[iLowest(NULL, 0, MODE_LOW,BarsBack,1)];  
      Low_Shift1= iBarShift(NULL, 0, Low_Time1, false);
      //---------------------------------------------------------    
      // Set the second point to be the 2nd bar as a starting point 
      //---------------------------------------------------------       
      Low_Price2 = Low[Low_Shift1-2];  
      Low_Time2 = Time[Low_Shift1-2];  
      Low_Shift2= Low_Shift1-2;
   }   

   //---------------------------------------------------------   
   // Delete trendline if TL_Low_Price1 has changed
   //---------------------------------------------------------            
   if ( ObjectGet(TL + "_Low" , OBJPROP_PRICE1) != Low_Price1 ) ObjectDelete(TL + "_Low" );
   
   //---------------------------------------------------------       
   // Draw Low TL
   //---------------------------------------------------------      
   if ( Low_Price1>0 && Low_Price2>0 
        && ObjectGet(TL + "_Low" , OBJPROP_PRICE2) != Low_Price2
   )
   {
      if (ObjectFind(TL + "_Low" ) < 0) 
      { 
         ObjectCreate(TL + "_Low" , OBJ_TREND, 0, Low_Time1, Low_Price1, Low_Time2, Low_Price2);
         ObjectSet(TL + "_Low" , OBJPROP_RAY, TRUE);
         ObjectSet(TL + "_Low" , OBJPROP_COLOR, Low_Colour);
         ObjectSet(TL + "_Low" , OBJPROP_STYLE, Style);
         ObjectSet(TL + "_Low" , OBJPROP_WIDTH, Width);         
      }
   }
   
   //---------------------------------------------------------    
   // Change the value of the second point if price penetrates the line
   //---------------------------------------------------------   
   if (Use_Close) 
   {
      for ( i=Low_Shift1-2; i>1; i-- )
       {
         if (  iClose(NULL, 0,i) < ObjectGetValueByShift(TL + "_Low" ,i) )
         {         
            ObjectMove(TL + "_Low" , 1, iTime(NULL, 0, i), iClose(NULL, 0,i) );       
         }
       }
   } else
   {
      for ( i=Low_Shift1-2; i>1; i-- )
       {
         if (  iLow(NULL, 0,i) < ObjectGetValueByShift(TL + "_Low" ,i) )
         {         
            ObjectMove(TL + "_Low" , 1, iTime(NULL, 0, i), iLow(NULL, 0,i) );       
         }
       }
   }      
} // DrawTL